/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg;

import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class ClosestNumberFinder {

    public static int findClosestNumber(List<Integer> numbers, int target) {
        // Initialize the closest number as the first element in the list
        int closest = numbers.get(0);
        // Set the minimum difference as the absolute difference between the first element and the target
        int minDiff = Math.abs(numbers.get(0) - target);

        // Iterate through the list starting from the second element
        for (int i = 1; i < numbers.size(); i++) {
            // Calculate the absolute difference for the current number
            int currentDiff = Math.abs(numbers.get(i) - target);

            // If the current difference is smaller than the minimum difference found so far
            if (currentDiff < minDiff) {
                minDiff = currentDiff;  // Update the minimum difference
                closest = numbers.get(i);  // Update the closest number
            }
        }
        return closest;
    }

    public static void main(String[] args) {
        List<Integer> numbers = List.of(6, -10, 2, 4, 8, 15);
        int target = 5;
        int result = findClosestNumber(numbers, target);
        System.out.println("Closest number to " + target + " is: " + result);
    }
}
