/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import java.util.Collections;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class ClosestNumberFinderBinarySearch {
    
    public static int findClosestNumberBinarySearch(List<Integer> numbers, int target) {
        
        // Perform binary search
        int index = Collections.binarySearch(numbers, target);
        
        // If exact target is found, return it
        if (index >= 0) {
            return numbers.get(index);
        }
        
        // If target is not found, binarySearch returns a negative insertion point (-insertion point - 1)
        int insertionPoint = -index - 1;

        // Compare numbers around the insertion point
        if (insertionPoint == 0) {
            return numbers.get(0); // Target is smaller than all elements, return the first element
        }
        if (insertionPoint == numbers.size()) {
            return numbers.get(numbers.size() - 1); // Target is larger than all elements, return the last element
        }
        
        // Get the closest of the two neighboring numbers
        int prev = numbers.get(insertionPoint - 1);
        int next = numbers.get(insertionPoint);
        
        // Return the number that is closer to the target
        return Math.abs(prev - target) <= Math.abs(next - target) ? prev : next;
    }

    // Main method for testing the solution
    public static void main(String[] args) {
        List<Integer> numbers = List.of(-10, 2, 4, 6, 8, 15); // Example Sorted list
        int target = 5; 
        int result = findClosestNumberBinarySearch(numbers, target);
        System.out.println("Closest number to " + target + " is: " + result);
    }

}
